Public Class frmMain

    Private m_cnADONetConnection As New OleDb.OleDbConnection()
    Private m_daDataAdapter As OleDb.OleDbDataAdapter
    Private m_cbCommandBuilder As OleDb.OleDbCommandBuilder
    Private m_dtContacts As New DataTable
    Private m_rowPosition As Integer = 0

    Private Sub frmMain_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        m_cnADONetConnection.Close()
        m_cnADONetConnection.Dispose()
    End Sub

    Private Sub ShowCurrentRecord()
        If m_dtContacts.Rows.Count = 0 Then
            txtContactName.Text = ""
            txtState.Text = ""
            Exit Sub
        End If

        txtContactName.Text = _
           m_dtContacts.Rows(m_rowPosition)("ContactName").ToString()
        txtState.Text = _
           m_dtContacts.Rows(m_rowPosition)("State").ToString()
    End Sub


    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_cnADONetConnection.ConnectionString = _
              "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\temp\contacts.mdb"
        m_cnADONetConnection.Open()

        m_daDataAdapter = _
              New OleDb.OleDbDataAdapter("Select * From Contacts", m_cnADONetConnection)

        m_cbCommandBuilder = New OleDb.OleDbCommandBuilder(m_daDataAdapter)

        m_daDataAdapter.Fill(m_dtContacts)

        Me.ShowCurrentRecord()
    End Sub

    Private Sub btnMoveFirst_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMoveFirst.Click
        ' Move to the first row and show the data.
        m_rowPosition = 0
        Me.ShowCurrentRecord()

    End Sub

    Private Sub btnMovePrevious_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMovePrevious.Click
        ' If not at the first row, go back one row and show the record.
        If m_rowPosition > 0 Then
            m_rowPosition = m_rowPosition - 1
            Me.ShowCurrentRecord()
        End If

    End Sub

    Private Sub btnMoveNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMoveNext.Click
        ' If not on the last row, advance one row and show the record.
        If m_rowPosition > (m_dtContacts.Rows.Count - 1) Then
            m_rowPosition = m_rowPosition + 1
            Me.ShowCurrentRecord()
        End If

    End Sub

    Private Sub btnMoveLast_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMoveLast.Click
        ' If there are any rows in the data table, move to the last and show the record.
        If m_dtContacts.Rows.Count > 0 Then
            m_rowPosition = m_dtContacts.Rows.Count - 1
            Me.ShowCurrentRecord()
        End If

    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        ' If there is existing data, update it.
        If m_dtContacts.Rows.Count <> 0 Then
            m_dtContacts.Rows(m_rowPosition)("ContactName") = txtContactName.Text
            m_dtContacts.Rows(m_rowPosition)("State") = txtState.Text
            m_daDataAdapter.Update(m_dtContacts)
        End If

    End Sub

    Private Sub btnAddNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddNew.Click
        Dim drNewRow As DataRow = m_dtContacts.NewRow()

        drNewRow("ContactName") = txtNewContactName.Text
        drNewRow("State") = txtNewState.Text
        m_dtContacts.Rows.Add(drNewRow)
        m_daDataAdapter.Update(m_dtContacts)
        m_rowPosition = m_dtContacts.Rows.Count - 1
        Me.ShowCurrentRecord()

    End Sub

    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        ' If there is data, delete the current row.
        If m_dtContacts.Rows.Count <> 0 Then
            m_dtContacts.Rows(m_rowPosition).Delete()
            m_daDataAdapter.Update(m_dtContacts)
            m_rowPosition = 0
            Me.ShowCurrentRecord()
        End If

    End Sub
End Class
